DROP TABLE IF EXISTS learningpoint.course_student;
DROP TABLE IF EXISTS learningpoint.course;
DROP VIEW IF EXISTS learningpoint.v_user;
DROP TABLE IF EXISTS learningpoint.seller;
DROP TABLE IF EXISTS learningpoint.student;

-- Table: learningpoint.seller
CREATE TABLE learningpoint.seller
(
  nif character varying(255) NOT NULL,
  email character varying(255),
  name character varying(255),
  password character varying(255),
  phone character varying(255),
  surname character varying(255),
  CONSTRAINT seller_pkey PRIMARY KEY (nif)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE learningpoint.seller
  OWNER TO "USER";

 -- Table: learningpoint.student
CREATE TABLE learningpoint.student
(
  nif character varying(255) NOT NULL,
  email character varying(255),
  name character varying(255),
  password character varying(255),
  phone character varying(255),
  surname character varying(255),
  CONSTRAINT student_pkey PRIMARY KEY (nif)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE learningpoint.student
  OWNER TO "USER";

  -- View: learningpoint.v_user
CREATE OR REPLACE VIEW learningpoint.v_user AS
SELECT nif, name, surname, phone, password, email, 'seller' as USERTYPE FROM learningpoint.seller 
UNION 
SELECT nif, name, surname, phone, password, email, 'student' as USERTYPE FROM learningpoint.student;
ALTER TABLE learningpoint.v_user
  OWNER TO "USER";

-- Table: learningpoint.course
CREATE TABLE learningpoint.course
(
  id serial NOT NULL,
  name character varying(255),
  description character varying(255),
  area character varying(255),
  startDate timestamp without time zone,
  endDate timestamp without time zone,
  url character varying(255),
  place character varying(255),
  seats integer,
  price double precision,
  nif character varying(255),
  CONSTRAINT course_pkey PRIMARY KEY (id),
  CONSTRAINT fk_k35yjqi8kj1r5gw2q3jwtahos FOREIGN KEY (nif)
      REFERENCES learningpoint.seller (nif) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE learningpoint.course
  OWNER TO "USER";
  
  -- Table: learningpoint.course_student
CREATE TABLE learningpoint.course_student
(
  "id_course" integer NOT NULL,
  "nif_student" character varying(255) NOT NULL,
  CONSTRAINT fk_b5svn5dgqv84we868r44r219v FOREIGN KEY ("nif_student")
      REFERENCES learningpoint.student (nif) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_fdb395hgb9wsvb8id838n8qtm FOREIGN KEY ("id_course")
      REFERENCES learningpoint.course (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE learningpoint.course_student
  OWNER TO "USER";  


INSERT INTO learningpoint.seller(nif, email, name, password, phone, surname) VALUES ('00000000X','manuel@mail.com', 'Manuel', 'PasswordManuel', '981898989', 'Iglesias');
INSERT INTO learningpoint.seller(nif, email, name, password, phone, surname) VALUES ('00000001X','antonio@mail.com', 'Antonio', 'PasswordAntonio', '981252525', 'Martin');
INSERT INTO learningpoint.seller(nif, email, name, password, phone, surname) VALUES ('00000002X','laura@mail.com', 'Laura', 'PasswordLaura', '981303030', 'Sanchez');

INSERT INTO learningpoint.student(nif, email, name, password, phone, surname)VALUES ('00000000Y','pablo@mail.com', 'Pablo', 'PasswordPablo', '981313131', 'Suarez');
INSERT INTO learningpoint.student(nif, email, name, password, phone, surname)VALUES ('00000001Y','pedro@mail.com', 'Pedro', 'PasswordPedro', '981333333', 'Cela');
INSERT INTO learningpoint.student(nif, email, name, password, phone, surname)VALUES ('00000002Y','jose@mail.com', 'Jose', 'PasswordJose', '981444444', 'Perez');

INSERT INTO learningpoint.course(name, description, area, startDate, endDate, url, place, seats, price, nif) 
 VALUES ('Python', 'Fundamentos de Python', 'Programación', to_date('10/01/2017','DD/MM/YYYY') , to_date('15/01/2016','DD/MM/YYYY'), 'www.pythoncourse.es', 'online', 
            '100','50.25', '00000000X');
INSERT INTO learningpoint.course(name, description, area, startDate, endDate, url, place, seats, price, nif) 
VALUES ('Perl', 'Fundamentos de Perl', 'Programación', to_date('10/02/2017','DD/MM/YYYY') , to_date('15/02/2017','DD/MM/YYYY'), 'www.perlcourse.es', 'Madrid', 
            '150','30.25', '00000000X');
INSERT INTO learningpoint.course(name, description, area, startDate, endDate, url, place, seats, price, nif) 
VALUES ('Cisco', 'Fundamentos de Cisco', 'Sistemas', to_date('10/04/2017','DD/MM/YYYY') , to_date('15/04/2017','DD/MM/YYYY'), 'www.ciscocourse.es', 'Barcelona', 
            '20','90.35', '00000001X');

INSERT INTO learningpoint.course_student(id_course, nif_student) VALUES (1, '00000000Y');
INSERT INTO learningpoint.course_student(id_course, nif_student) VALUES (1, '00000001Y');
INSERT INTO learningpoint.course_student(id_course, nif_student) VALUES (1, '00000002Y');
INSERT INTO learningpoint.course_student(id_course, nif_student) VALUES (2, '00000001Y');
INSERT INTO learningpoint.course_student(id_course, nif_student) VALUES (3, '00000002Y');
INSERT INTO learningpoint.course_student(id_course, nif_student) VALUES (3, '00000001Y');
INSERT INTO learningpoint.course_student(id_course, nif_student) VALUES (3, '00000000Y');