package edu.uoc.tfg.learningpoint.business.courseadministration;

import java.util.Collection;

import javax.ejb.Local;

import edu.uoc.tfg.learningpoint.business.useradministration.ITicket;
import edu.uoc.tfg.learningpoint.exception.LearningPointException;
import edu.uoc.tfg.learningpoint.integration.SellerJPA;
import edu.uoc.tfg.learningpoint.integration.StudentJPA;
import edu.uoc.tfg.learningpoint.integration.CourseJPA;



/**
 * Session EJB Local Interfaces
 */
@Local
public interface CourseAdministrationFacadeLocal {
	 /**
	   * Localy invoked method.
	   */
	  public java.util.Collection<SellerJPA> listAllSellers( ITicket ticket ) throws LearningPointException; 
	  public Collection<CourseJPA> listCoursesBySeller( final ITicket ticket) throws LearningPointException;
	  public Collection<CourseJPA> listCourses( final ITicket ticket) throws LearningPointException;
	  public Collection<StudentJPA> listStudentsByCourse( final ITicket ticket, final CourseJPA course ) throws LearningPointException;
	  public StudentJPA showStudent( final ITicket ticket ) throws LearningPointException;
	  public CourseJPA showCourse(  final ITicket ticket , final CourseJPA course ) throws LearningPointException;
	  public void addCourse( final ITicket ticket, final CourseJPA course ) throws LearningPointException;
	  public void updateCourse( final ITicket ticket, final CourseJPA course ) throws LearningPointException ;
}