package edu.uoc.tfg.learningpoint.business.useradministration;

import java.util.List;

import javax.ejb.Remote;

import edu.uoc.tfg.learningpoint.exception.LearningPointException;
import edu.uoc.tfg.learningpoint.integration.SellerJPA;
import edu.uoc.tfg.learningpoint.integration.IUserJPA;
import edu.uoc.tfg.learningpoint.integration.StudentJPA;
import edu.uoc.tfg.learningpoint.integration.UserJPA;

/**
 * UserFacadeRemote
 * @author maip
 */
@Remote
public interface UserFacadeRemote {

	/**
	 * login
	 * @param email
	 * @param password
	 * @return ITicket
	 * @throws LearningPointException
	 */
	public ITicket login ( final String email, final String password ) throws LearningPointException;
	
	/**
	 * logout
	 * @param ticket
	 */
	public void logout ( final ITicket ticket );
	
	/**
	 * registerSeller
	 * @param ticket
	 * @param sellerJPA
	 * @throws LearningPointException
	 */
	public void registerSeller ( final ITicket ticket, SellerJPA sellerJPA ) throws LearningPointException;
	
	/**
	 * updatePersonalData
	 * @param ticket
	 * @param userJPA
	 * @throws LearningPointException
	 */
	public void updatePersonalData ( final ITicket ticket, final IUserJPA userJPA ) throws LearningPointException; 		
	
	/**
	 * registerStudent
	 * @param ticket
	 * @param studentJPA
	 * @throws LearningPointException
	 */
	public void registerStudent ( final ITicket ticket, final StudentJPA studentJPA ) throws LearningPointException;
	
	/**
	 * getUserJPA
	 * @param ticket
	 * @return
	 * @throws LearningPointException
	 */
	public UserJPA getUserJPA ( final ITicket ticket ) throws LearningPointException;
	
}
