package edu.uoc.tfg.learningpoint.integration;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Embeddable;

/**
 * CourseStudentID
 * @author maip
 */
@Embeddable
public class CourseStudentID implements Serializable {

	/**
	 * SerialID
	 */
	private static final long serialVersionUID = -4612860006919029860L;
	
	@Column(name="id_course", insertable=true, updatable=true)
	private Integer idCourse;
	
	@Column(name="nif_student", insertable=true, updatable=true)
	private String nifStudent;

	
	public CourseStudentID(){
		super();
	}
			
	
	public CourseStudentID(Integer idCourse, String nifStudent) {
		super();
		this.idCourse = idCourse;
		this.nifStudent = nifStudent;
	}


	public Integer getIdCourse() {
		return idCourse;
	}


	public void setIdCourse(Integer idCourse) {
		this.idCourse = idCourse;
	}


	public String getNifStudent() {
		return nifStudent;
	}


	public void setNifStudent(String nifStudent) {
		this.nifStudent = nifStudent;
	}


	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((idCourse == null) ? 0 : idCourse.hashCode());
		result = prime * result + ((nifStudent == null) ? 0 : nifStudent.hashCode());
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CourseStudentID other = (CourseStudentID) obj;
		if (idCourse == null) {
			if (other.idCourse != null)
				return false;
		} else if (!idCourse.equals(other.idCourse))
			return false;
		if (nifStudent == null) {
			if (other.nifStudent != null)
				return false;
		} else if (!nifStudent.equals(other.nifStudent))
			return false;
		return true;
	}


	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("CourseStudentID [");
		if (idCourse != null) {
			builder.append("idCourse=");
			builder.append(idCourse);
			builder.append(", ");
		}
		if (nifStudent != null) {
			builder.append("nifStudent=");
			builder.append(nifStudent);
		}
		builder.append("]");
		return builder.toString();
	}
	
	
	
	
}
