package edu.uoc.tfg.learningpoint.integration;

import java.io.Serializable;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

/**
 * CourseStudentJPA
 * @author maip
 */
@Entity
@Table(name="learningpoint.course_student")
public class CourseStudentJPA implements Serializable {
	
	/**
	 * SerialID
	 */
	private static final long serialVersionUID = 2243260747077885892L;


	@EmbeddedId
	private CourseStudentID id;
	
	
	@ManyToOne
	@JoinColumn(	name = "id_course", referencedColumnName = "id",
					 insertable = false, updatable = false)
	private CourseJPA courseJPA;
	
	
	@ManyToOne
	@JoinColumn(	name = "nif_student", referencedColumnName = "nif",
				    insertable = false, updatable = false)
	private StudentJPA studentJPA;


	
	public CourseStudentJPA(){
		super();
	}
	
	
	
	
	public CourseStudentID getId() {
		return id;
	}


	public void setId(CourseStudentID id) {
		this.id = id;
	}


	public CourseJPA getCourseJPA() {
		return courseJPA;
	}


	public void setCourseJPA(CourseJPA courseJPA) {
		this.courseJPA = courseJPA;
	}


	public StudentJPA getStudentJPA() {
		return studentJPA;
	}


	public void setStudentJPA(StudentJPA studentJPA) {
		this.studentJPA = studentJPA;
	}




	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}




	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CourseStudentJPA other = (CourseStudentJPA) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}




	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("CourseStudentJPA [");
		if (id != null) {
			builder.append("id=");
			builder.append(id);
			builder.append(", ");
		}
		builder.append("]");
		return builder.toString();
	}
	
	
	
	
	
}
