package edu.uoc.tfg.learningpoint.presentation.courseadministration;

import java.io.Serializable;

import javax.faces.bean.ManagedProperty;
import javax.faces.context.FacesContext;

import edu.uoc.tfg.learningpoint.business.courseadministration.CourseAdministrationFacadeLocal;
import edu.uoc.tfg.learningpoint.business.useradministration.ITicket;
import edu.uoc.tfg.learningpoint.business.useradministration.Ticket;
import edu.uoc.tfg.learningpoint.presentation.utils.FacadeServicesEJB;

@SuppressWarnings("serial")
public abstract class AbstractCourseAdministration implements Serializable, ICourseAdministration {

    @ManagedProperty( value = "#{facadeServicesEJB}" )
    private FacadeServicesEJB facadeServicesEJB;
    
    
	@Override
	public CourseAdministrationFacadeLocal getCourseAdministrationFacade() throws Exception {
		return facadeServicesEJB.getCourseAdministrationFacade();
	}
    
	public FacadeServicesEJB getFacadeServicesEJB() {
		return facadeServicesEJB;
	}

	public void setFacadeServicesEJB(FacadeServicesEJB facadeServicesEJB) {
		this.facadeServicesEJB = facadeServicesEJB;
	}
	
	protected ITicket getTicket() {
		FacesContext context = FacesContext.getCurrentInstance();
		ITicket ticket = (ITicket) context.getExternalContext().getSessionMap().get("ticket");		
		
		if (ticket == null) {
			ticket = Ticket.getInvalidTicket("", "");//init ticket, evict nullpointer
		}
		
		return ticket;
	}
	
}
