package edu.uoc.tfg.learningpoint.presentation.courseadministration;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

import edu.uoc.tfg.learningpoint.exception.LearningPointException;
import edu.uoc.tfg.learningpoint.integration.CourseJPA;
import edu.uoc.tfg.learningpoint.presentation.navigation.NavigationMBean;

/**
* Managed Bean AddCourseMBean
*/
@ManagedBean(name = MBeanNames.ADD_COURSE_MBEAN )
@SessionScoped
public class AddCourseMBean extends AbstractCourseAdministration{
	
	private static final long serialVersionUID = 1L;
	
	private CourseJPA courseJPA; 

	
	public AddCourseMBean() throws Exception {
		super();
		System.out.println(">>>init AddCourseMBean...");		
		resetModel();

	}
	
	public String addCourse()  {
		System.out.println(">>>addCourse...");
		
		try {
			
			getCourseAdministrationFacade().addCourse( getTicket(), courseJPA );
			resetModel();//clean course
			
		} catch (LearningPointException e) {
			System.err.println( String.format (  "%s : %s ", this.getClass(), e.getMessage() ) );
			FacesContext.getCurrentInstance().addMessage("errors", new FacesMessage( e.getMessage() ) );
			return null;
		} catch (Exception e) {
			return null;
		}
		
		return NavigationMBean.toFindMyCoursesView();
	}




	public CourseJPA getCourseJPA() {
		return courseJPA;
	}

	public void setCourseJPA(CourseJPA courseJPA) {
		this.courseJPA = courseJPA;
	}


	private void resetModel(){
		courseJPA = new CourseJPA();
	}



}
