package edu.uoc.tfg.learningpoint.presentation.courseadministration;

import java.util.ArrayList;
import java.util.Collection;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

import edu.uoc.tfg.learningpoint.exception.LearningPointException;
import edu.uoc.tfg.learningpoint.integration.StudentJPA;
import edu.uoc.tfg.learningpoint.integration.CourseJPA;

/**
 * Managed Bean FindAllStudentsMBean
 */
@ManagedBean(name = MBeanNames.FIND_ALL_STUDENTS_MBEAN )
@SessionScoped
public class FindAllStudentsMBean extends AbstractCourseAdministration {
	
	private static final long serialVersionUID = 1L;	

	
	private Collection<StudentJPA> listStudentJPA;
	
	private Integer idCourse;
	
	private boolean isThereRows;
	
	private CourseJPA courseJPA;


	
	public FindAllStudentsMBean() throws Exception {
		super();
		System.out.println(">>>init FindAllStudentsMBean...");
		resetModel();

	}
	


	public Collection<StudentJPA> getListStudentJPA() {
		
		try {
			
			listStudentJPA = getCourseAdministrationFacade().listStudentsByCourse( getTicket(), courseJPA );
			isThereRows = (listStudentJPA.size() > 0 );
			
		} catch (LearningPointException e) {
			System.err.println( String.format ( "%s : %s ", this.getClass(), e.getMessage() ) );
			FacesContext.getCurrentInstance().addMessage("errors", new FacesMessage( e.getMessage() ) );
			return null;
		} catch (Exception e) {
			return null;
		}
		
		
		return listStudentJPA;
	}


	
	private void resetModel(){
		listStudentJPA = new ArrayList<StudentJPA>();
		isThereRows = false;
	}
	
	public boolean getIsThereRows() {
		return isThereRows;
	}

	
    public CourseJPA getCourseJPA() {
		return courseJPA;
	}



	public void setCourseJPA(CourseJPA courseJPA) {
		this.courseJPA = courseJPA;
	}
	
	public void setIdCourse(Integer idCourse) {
		
		if (courseJPA == null) {
			courseJPA = new CourseJPA();
		}

        courseJPA.setId( idCourse );
		this.idCourse = idCourse;
	}
	
	
	public Integer getIdCourse() {
		
		return idCourse;
	}
}
