package edu.uoc.tfg.learningpoint.presentation.courseadministration;

import java.util.ArrayList;
import java.util.Collection;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

import edu.uoc.tfg.learningpoint.exception.LearningPointException;
import edu.uoc.tfg.learningpoint.integration.CourseJPA;

/**
 * Managed Bean FindMyCoursesMBean
 */
@ManagedBean(name = MBeanNames.FIND_MY_COURSES_MBEAN )
@SessionScoped
public class FindMyCoursesMBean extends AbstractCourseAdministration{

	private static final long serialVersionUID = 1L;
	
	private Collection<CourseJPA> listCourseJPA;
	
	private boolean isThereRows;

	
	public FindMyCoursesMBean() throws Exception {
		super();
		System.out.println(">>>init FindMyCoursesMBean...");
		resetModel();

	}

	public Collection<CourseJPA> getListCourseJPA() {
		
		try {
			
			listCourseJPA = getCourseAdministrationFacade().listCourses ( getTicket() );
			isThereRows = (listCourseJPA.size() > 0 );
			
		} catch (LearningPointException e) {
			System.err.println( String.format ( "%s : %s ", this.getClass(), e.getMessage() ) );
			FacesContext.getCurrentInstance().addMessage("errors", new FacesMessage( e.getMessage() ) );
			return null;
		} catch (Exception e) {
			return null;
		}
		
		
		return listCourseJPA;
	}


	private void resetModel(){
		listCourseJPA = new ArrayList<CourseJPA>();
		isThereRows = false;
	}
	
	public boolean getIsThereRows() {
		return isThereRows;
	}

	
	
}
