package edu.uoc.tfg.learningpoint.presentation.courseadministration;

import java.util.ArrayList;
import java.util.Collection;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

import edu.uoc.tfg.learningpoint.exception.LearningPointException;
import edu.uoc.tfg.learningpoint.integration.SellerJPA;

/**
 * Managed Bean ListSellersMBean
 */
@ManagedBean(name = MBeanNames.LIST_SELLERS_MBEAN )
@SessionScoped
public class ListSellersMBean extends AbstractCourseAdministration {
	
	private static final long serialVersionUID = 1L;
	
	
	private Collection<SellerJPA> listSellersJPA;
	
	private boolean isThereRows;


	
	public ListSellersMBean() throws Exception {
		super();
		System.out.println(">>>init ListSellersMBean...");	
		resetModel();

	}
	


	public Collection<SellerJPA> getListCourseJPA() {
		
		try {
			
			listSellersJPA = getCourseAdministrationFacade().listAllSellers( getTicket() );
			isThereRows = (listSellersJPA.size() > 0 );
			
		} catch (LearningPointException e) {
			System.err.println( String.format ( "%s : %s ", this.getClass(), e.getMessage() ) );
			FacesContext.getCurrentInstance().addMessage("errors", new FacesMessage( e.getMessage() ) );
			return null;
		} catch (Exception e) {
			return null;
		}
		
		
		return listSellersJPA;
	}

	

	
	private void resetModel(){
		listSellersJPA = new ArrayList<SellerJPA>();
		isThereRows = false;
	}
	
	public boolean getIsThereRows() {
		return isThereRows;
	}


	public Collection<SellerJPA> getListSellersJPA() {
		return listSellersJPA;
	}



	public void setListSellersJPA(Collection<SellerJPA> listSellersJPA) {
		this.listSellersJPA = listSellersJPA;
	}



	public void setThereRows(boolean isThereRows) {
		this.isThereRows = isThereRows;
	}
	
	
 
}
