package edu.uoc.tfg.learningpoint.presentation.courseadministration;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

import edu.uoc.tfg.learningpoint.exception.LearningPointException;
import edu.uoc.tfg.learningpoint.integration.CourseJPA;
import edu.uoc.tfg.learningpoint.presentation.navigation.NavigationMBean;

/**
* Managed Bean UpdateCourseInformationMBean
*/
@ManagedBean(name = MBeanNames.UPDATE_COURSE_INFORMATION_MBEAN)
@SessionScoped
public class UpdateCourseInformationMBean extends AbstractCourseAdministration {


	private static final long serialVersionUID = 1L;
	
	private CourseJPA courseJPA; 

	private Integer idCourse;

	
	
	public UpdateCourseInformationMBean() throws Exception {
		super();
		System.out.println(">>>init UpdateCourseInformationMBean...");
		resetModel();

	}
	
	public String updateCourse()  {
		System.out.println(">>>updateCourse...");
		
		try {
			
			getCourseAdministrationFacade().updateCourse( getTicket(), courseJPA );
			resetModel();//clean 
			
		} catch (LearningPointException e) {
			System.err.println( String.format ( "%s : %s ", this.getClass(), e.getMessage() ) );
			FacesContext.getCurrentInstance().addMessage("errors", new FacesMessage( e.getMessage() ) );
			return null;
		} catch (Exception e) {
			return null;
		}
		
		return NavigationMBean.toFindMyCoursesView();
	}


	private void resetModel(){
		courseJPA = new CourseJPA();
	}

	
	public void setIdCourse(Integer idCourse) {
		
		if (courseJPA == null) {
			courseJPA = new CourseJPA();
		}

        courseJPA.setId( idCourse );
        try {
        	courseJPA = getCourseAdministrationFacade().showCourse( getTicket(), courseJPA);
		} catch (LearningPointException e) {
			System.err.println( String.format ( "%s : %s ", this.getClass(), e.getMessage() ) );
		} catch (Exception e) {
			System.err.println( String.format ( "%s : %s ", this.getClass(), e.getMessage() ) );
		}

		this.idCourse = idCourse;
	}
	
	
	public Integer getIdCourse() {
		
		return idCourse;
	}
	
	public CourseJPA getCourseJPA() {
		
		return courseJPA;
	}

	public void setCourseJPA(CourseJPA courseJPA) {
		this.courseJPA = courseJPA;
	}
	
	
}
