package edu.uoc.tfg.learningpoint.presentation.useradministration;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

import edu.uoc.tfg.learningpoint.exception.LearningPointException;
import edu.uoc.tfg.learningpoint.exception.ValidationError;
import edu.uoc.tfg.learningpoint.integration.SellerJPA;
import edu.uoc.tfg.learningpoint.integration.StudentJPA;
import edu.uoc.tfg.learningpoint.integration.UserJPA;

/**
* Managed Bean RegisterSellerMBean
* @author maip
*/
@ManagedBean(name = MBeanNames.REGISTER_USER_MBEAN)
@SessionScoped
public class RegisterUserMBean extends AbstractUserAdministration {
	
	private static final long serialVersionUID = 1L;
	
	private boolean showSuccess = false;
	
	private UserJPA userJPA;

	
	public RegisterUserMBean () {
		super();
		System.out.println(">>>init RegisterUserMBean...");
		resetModel();
	}
	
	public String registerUser () throws Exception {
		System.out.println(">>>registerUser...");
		try {
			
			if (userJPA.getUserType().equals( StudentJPA.USER_TYPE )) {
				getUserFacade().registerStudent( getTicket(), new StudentJPA(userJPA) );
			} else {
				getUserFacade().registerSeller( getTicket(), new SellerJPA(userJPA) );
			}

			resetModel();
			showSuccess = true;
//			FacesContext.getCurrentInstance().addMessage("success", new FacesMessage( "Cuenta de usuario creada con exito" ));
		} catch (LearningPointException e) {
			System.err.println( String.format (  "%s : %s ", this.getClass(), e.getMessage() ) );
			for ( ValidationError error : e.getErrors()) {
				FacesContext.getCurrentInstance().addMessage("errors", new FacesMessage( error.getMessageError() ));
			}
			return null;
		} catch (Exception e) {
			System.err.println( String.format (  "%s : %s ", this.getClass(), e.getMessage() ) );
			return null;
		}
		return null;
	}

	

	public UserJPA getUserJPA() {
		return userJPA;
	}

	public void setUserJPA(UserJPA userJPA) {
		this.userJPA = userJPA;
	}

	
	private void resetModel(){
		userJPA = new UserJPA();
	}
	
	/**
	 * coge el valor de la variable y la settea a false
	 * @return
	 */
	public boolean getShowSuccess() {
		return showSuccess;
	}


	public void setShowSuccess(boolean showSuccess) {
		this.showSuccess = showSuccess;
	}

	/**
	 * coge el valor de la variable y la settea a false
	 * @return
	 */
	public boolean getResetShowSuccess() {
		showSuccess = false;
		return true;
	}
	


}
