package edu.uoc.tfg.learningpoint.presentation.useradministration;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;


import edu.uoc.tfg.learningpoint.exception.LearningPointException;
import edu.uoc.tfg.learningpoint.exception.ValidationError;
import edu.uoc.tfg.learningpoint.integration.UserJPA;
import edu.uoc.tfg.learningpoint.presentation.navigation.NavigationMBean;

/**
* Managed Bean UpdatePersonalDataMBean
* @author maip
*/
@ManagedBean(name = MBeanNames.UPDATE_PERSONAL_DATA_MBEAN)
@SessionScoped
public class UpdatePersonalDataMBean extends AbstractUserAdministration {

	/**
	 * Serial ID
	 */
	private static final long serialVersionUID = 2879489712880346072L;

	private UserJPA userJPA;
	
	private String nif;
	private String email;
	private String name;
	private String password;
	private String phone;
	private String surname;
	private String userType;
	
	
	public UpdatePersonalDataMBean(){
		super();
		System.out.println(">>>init UpdatePersonalDataMBean...");
		resetModel();
		this.nif = getTicket().getNif();	
		if (getTicket().isSeller()){
			this.userType = "seller";
		}
		else{
			this.userType = "student";
		}
		this.email = getTicket().getEmail();
		this.password = getTicket().getPassword();
		this.name = getTicket().getName();
		this.surname = getTicket().getSurname();
		this.phone = getTicket().getPhone();
		userJPA.setEmail(this.email);
		System.out.println(userJPA.getEmail());
		userJPA.setName(this.name);
		System.out.println(userJPA.getName());
		userJPA.setPassword(this.password);
		System.out.println(userJPA.getPassword());
		userJPA.setPhone(this.phone);
		System.out.println(userJPA.getPhone());
		userJPA.setSurname(this.surname);
		System.out.println(userJPA.getSurname());
		
	}
	
	public String updatePersonalData () throws Exception {
		System.out.println(">>>RegisterUser...");
		
		userJPA.setEmail(this.email);
		System.out.println(userJPA.getEmail());
		userJPA.setName(this.name);
		System.out.println(userJPA.getName());
		userJPA.setPassword(this.password);
		System.out.println(userJPA.getPassword());
		userJPA.setPhone(this.phone);
		System.out.println(userJPA.getPhone());
		userJPA.setSurname(this.surname);
		System.out.println(userJPA.getSurname());
		
		
		try {
			
			getUserFacade().updatePersonalData( getTicket(), userJPA);
//			final String success = "La operación se ha realizado con exito.";
//			FacesContext.getCurrentInstance().addMessage("success", new FacesMessage( success ));
			resetModel();
			
		} catch (LearningPointException e) {
			System.err.println( String.format ( "%s : %s ", this.getClass(), e.getMessage() ) );
			for ( ValidationError error : e.getErrors()) {
				FacesContext.getCurrentInstance().addMessage("errors", new FacesMessage( error.getMessageError() ));
			}
			return null;
		} catch (Exception e) {
			System.err.println( String.format (  "%s : %s ", this.getClass(), e.getMessage() ) );
			return null;
		}
		return NavigationMBean.toMainView();
	}
	

	public UserJPA getUserJPA() {
		
		try {
			System.out.println(">>>getUser...");
			userJPA = getUserFacade().getUserJPA( getTicket() );
		
			this.nif = userJPA.getNif();
			this.email = userJPA.getEmail();			
			this.name = userJPA.getName();			
			this.password = userJPA.getPassword();
			this.phone = userJPA.getPhone();
			this.surname = userJPA.getSurname();
			this.userType = userJPA.getUserType();
			
		} catch (Exception e) {
			System.err.println( String.format (  "%s : %s ", this.getClass(), e.getMessage() ) );
			return null;
		}
		
		return userJPA;
	}
	
	public void setUserJPA(UserJPA userJPA) {
		System.out.println(">>>SetUser...");
		this.userJPA = userJPA;
		
		
	}
	
	public String getNif() {
		
			
		return nif;
	}
	
	public void setNif(String nif) {
		
		this.nif = nif;
		
	}
	
	public String getEmail() {
		
		
		return email;
	}
	
	public void setEmail(String email) {
		
		this.email = email;
		
	}
	
	public String getName() {
		
		
		return name;
	}
	
	public void setName(String name) {
		
		this.name = name;
		
	}
	
	public String getPassword() {
		
		
		return password;
	}
	
	public void setPassword(String password) {
		
		this.password = password;
		
	}
	
	public String getPhone() {
		
		
		return phone;
	}
	
	public void setPhone(String phone) {
		
		this.phone = phone;
		
	}
	
	public String getSurname() {
		
		
		return surname;
	}
	
	public void setSurname(String surname) {
		
		this.surname = surname;
		
	}
	
	public String getUserType() {
		
		
		return userType;
	}
	
	public void setUserType(String userType) {
		
		this.userType = userType;
		
	}
	
	private void resetModel(){
		userJPA = new UserJPA();
		getUserJPA();		
	}
	
	
	
}
