package edu.uoc.tfg.learningpoint.presentation.utils;

import java.io.Serializable;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.naming.Context;
import javax.naming.InitialContext;

import edu.uoc.tfg.learningpoint.business.courseadministration.CourseAdministrationFacadeLocal;
import edu.uoc.tfg.learningpoint.business.useradministration.UserFacadeLocal;


/**
 * LookUpNames
 * @author maip
 */
@ManagedBean(name = MBeanNames.FACADE_SERVICES_EJB_MBEAN)
@SessionScoped
public class FacadeServicesEJB implements Serializable {

	/**
	 * Serial ID
	 */
	private static final long serialVersionUID = 1L;

	public static final String USER_FACADE_BEAN_LOOKUP = "java:app/tfgLearningPointEJB.jar/UserFacadeBean!ejb.UserFacadeLocal";
	
	public static final String COURSE_ADMINISTRATION_BEAN_LOOKUP = "java:app/tfgLearningPointEJB.jar/CourseAdministrationFacadeBean!ejb.CourseAdministrationFacadeLocal";
	
	@EJB
	private UserFacadeLocal userFacade;
	
	@EJB
	private CourseAdministrationFacadeLocal courseAdministrationFacade;
	
	
	
	
	public UserFacadeLocal getUserFacade() throws Exception {
		
		try {
			
			if ( userFacade == null ) {

				final Properties props = System.getProperties();
				final Context ctx = new InitialContext(props);
				userFacade = (UserFacadeLocal) ctx.lookup( FacadeServicesEJB.USER_FACADE_BEAN_LOOKUP );
			}
			
		} catch (Exception e) {
			
			System.err.println( String.format("No se ha podido obtener una referencia del EJB en cuestion. Revisar el lookup. %s : %s", this.getClass(), e.getMessage() ) );
			throw e;
		}

		return userFacade;
	}
	
	public CourseAdministrationFacadeLocal getCourseAdministrationFacade() throws Exception {

		try {
			
			if ( courseAdministrationFacade == null ) {
			
				final Properties props = System.getProperties();
				final Context ctx = new InitialContext(props);
				courseAdministrationFacade = (CourseAdministrationFacadeLocal) ctx.lookup( FacadeServicesEJB.COURSE_ADMINISTRATION_BEAN_LOOKUP );
			}
			
		} catch (Exception e) {
			
			System.err.println( String.format("No se ha podido obtener una referencia del EJB en cuestion. Revisar el lookup. %s : %s", this.getClass(), e.getMessage() ) );
			throw e;
		}


		return courseAdministrationFacade;
	}
	
}
